package jumpstart.web.pages.examples.ajax;

import jumpstart.web.pages.Index;

import org.apache.tapestry5.ComponentResources;
import org.apache.tapestry5.annotations.InjectComponent;
import org.apache.tapestry5.annotations.InjectPage;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.corelib.components.Zone;
import org.apache.tapestry5.ioc.annotations.Inject;
import org.apache.tapestry5.services.Request;

public class AJAXSelect1 {
	static final private String[] ALL_MAKES = new String[] { "Honda", "Toyota" };
	static final private String[] NO_MODELS = new String[] {};
	static final private String[] HONDA_MODELS = new String[] { "Accord", "Civic", "Jazz" };
	static final private String[] TOYOTA_MODELS = new String[] { "Camry", "Corolla" };

	// Screen fields

	@Property
	private String carMake;

	@Property
	private String carModel;

	@Property
	private String keywords;

	@Property
	private String[] carMakes;

	@Property
	@SuppressWarnings("unused")
	private String[] carModels;

	// Other pages

	@InjectPage
	private AJAXSelect2 page2;

	// Generally useful bits and pieces

	@InjectComponent
	private Zone carModelZone;

	@Inject
	private ComponentResources componentResources;

	@Inject
	private Request request;

	// The code

	void setupRender() {
		if (carMakes == null) {
			carMakes = ALL_MAKES;
			carModels = NO_MODELS;
		}
	}

	Object onValueChangedFromCarMake(String carMake) {
		this.carMake = carMake;
		carMakes = ALL_MAKES;

		if (carMake == null) {
			carModels = NO_MODELS;
		}
		else if (carMake.equals(carMakes[0])) {
			carModels = HONDA_MODELS;
		}
		else if (carMake.equals(carMakes[1])) {
			carModels = TOYOTA_MODELS;
		}
		else {
			carModels = NO_MODELS;
		}
		carModel = null;

		return request.isXHR() ? carModelZone.getBody() : null;
	}

	Object onSuccess() {
		page2.set(carMake, carModel, keywords);
		componentResources.discardPersistentFieldChanges();
		return page2;
	}

	Object onGoHome() {
		componentResources.discardPersistentFieldChanges();
		return Index.class;
	}
}
