package jumpstart.web.pages.examples.select;

import java.util.List;

import javax.ejb.EJB;

import jumpstart.business.domain.examples.Person;
import jumpstart.business.domain.examples.iface.IPersonServiceLocal;
import jumpstart.web.services.SelectIdModelFactory;

import org.apache.tapestry5.EventContext;
import org.apache.tapestry5.SelectModel;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.ioc.annotations.Inject;

public class EasyIdSelect {
	private final int MAX_RESULTS = 30;

	// The activation context

	@Property
	private Long personId;

	// Screen fields

	@Property
	@SuppressWarnings("unused")
	private SelectModel personIdsModel;

	// Generally useful bits and pieces

	@Inject
	private SelectIdModelFactory selectIdModelFactory;

	@EJB
	private IPersonServiceLocal personService;

	// The code

	Long onPassivate() {
		return personId;
	}

	void onActivate(EventContext context) {
		if (context.getCount() > 0) {
			personId = context.get(Long.class, 0);
		}
	}

	void setupRender() {
		// Get all persons - ask business service to find them (from the database)
		List<Person> persons = personService.findPersons(MAX_RESULTS);

		personIdsModel = selectIdModelFactory.create(persons, "firstName", "id");
	}

}
